diff --git a/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java b/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java
index a72ce58..2128c1e 100644
--- a/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java
+++ b/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java
@@ -609,70 +628,82 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                                 Name name = template.getSubject();
 
                                 // xxx do we need to do anything else?
-                                X509CertInfo certInfo =
-                                        CMS.getDefaultX509CertInfo();
+                                X509CertInfo certInfo = CMS.getDefaultX509CertInfo();
 
                                 // reset value of auditCertSubject
                                 if (name != null) {
                                     String ss = name.getRFC1485();
 
+                                    CMS.debug(method + "setting auditCertSubject to: " + ss);
                                     auditCertSubject = ss;
                                     if (auditCertSubject.equals("")) {
-                                        auditCertSubject =
-                                                ILogger.SIGNED_AUDIT_EMPTY_VALUE;
+                                        auditCertSubject = ILogger.SIGNED_AUDIT_EMPTY_VALUE;
                                     }
 
                                     authToken.set(AuthToken.TOKEN_CERT_SUBJECT, ss);
-                                    authToken.set("uid", uid);
-                                    authToken.set("userid", userid);
+                                    //authToken.set("uid", uid);
+                                    //authToken.set("userid", userid);
                                 }
                                 certInfoArray[i] = certInfo;
-                            } catch (Exception e) {
-                                // store a message in the signed audit log file
-                                auditMessage = CMS.getLogMessage(
-                                        AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY,
-                                        auditSubjectID,
-                                        ILogger.FAILURE,
-                                        auditReqType,
-                                        auditCertSubject,
-                                        auditSignerInfo);
 
-                                audit(auditMessage);
+                                if (selfSigned) {
+                                    selfsign_skiExtn =
+                                            (SubjectKeyIdentifierExtension) CryptoUtil
+                                            .getExtensionFromCertTemplate(template, PKIXExtensions.SubjectKey_Id);
+                                    if (selfsign_skiExtn != null) {
+                                        CMS.debug(method +
+                                                "SubjectKeyIdentifierExtension found");
+                                    } else {
+                                        CMS.debug(method +
+                                                "SubjectKeyIdentifierExtension not found");
+                                    }
+
+                                    // get public key for verifying signature later
+                                    SubjectPublicKeyInfo pkinfo = template.getPublicKey();
+                                    PrivateKey.Type keyType = null;
+                                    String alg = pkinfo.getAlgorithm();
+                                    BIT_STRING bitString = pkinfo.getSubjectPublicKey();
+                                    byte[] publicKeyData = bitString.getBits();
+                                    if (alg.equals("RSA")) {
+                                        CMS.debug(method + "signing key alg=RSA");
+                                        keyType = PrivateKey.RSA;
+                                        selfsign_pubK = PK11PubKey.fromRaw(keyType, publicKeyData);
+                                    } else if (alg.equals("EC")) {
+                                        CMS.debug(method + "signing key alg=EC");
+                                        keyType = PrivateKey.EC;
+                                        selfsign_pubK = PK11ECPublicKey.fromSPKI(/*keyType,*/ publicKeyData);
+                                    } else {
+                                        msg = "unsupported signature algorithm: " + alg;
+                                        CMS.debug(method + msg);
+                                        throw new EInvalidCredentials(msg);
+                                    }
+                                    CMS.debug(method + "public key retrieved");
 
-                                //throw new ECMSGWException(
-                                //CMSGWResources.ERROR_PKCS101, e.toString());
+                                    verifySelfSignedCMC(selfsign_signerInfo, id);
+                                } //selfSigned
 
+                            } catch (Exception e) {
                                 e.printStackTrace();
+                                cmcBlobIn.close();
+                                s.close();
                                 throw new EBaseException(e.toString());
                             }
                         }
 
-                        // authToken.set(AgentAuthentication.CRED_CERT, new
-                        //     com.netscape.certsrv.usrgrp.Certificates(
-                        //     x509Certs));
                     }
                 }
+
+                authToken.set("uid", uid);
+                authToken.set("userid", userid);
             } catch (Exception e) {
                 CMS.debug(method + e);
-                // store a message in the signed audit log file
-                auditMessage = CMS.getLogMessage(
-                        AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY,
-                        auditSubjectID,
-                        ILogger.FAILURE,
-                        auditReqType,
-                        auditCertSubject,
-                        auditSignerInfo);
-
-                audit(auditMessage);
-
                 //Debug.printStackTrace(e);
-                throw new EInvalidCredentials(CMS.getUserMessage(
-                        "CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
+                throw new EInvalidCredentials(e.toString());
             }
 
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY,
+                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS,
                     auditSubjectID,
                     ILogger.SUCCESS,
                     auditReqType,
@@ -687,12 +718,13 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
             CMS.debug(method + eAudit1);
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY,
+                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_FAILURE,
                     auditSubjectID,
                     ILogger.FAILURE,
                     auditReqType,
                     auditCertSubject,
-                    auditSignerInfo);
+                    auditSignerInfo,
+                    eAudit1.toString());
 
             audit(auditMessage);
 
@@ -702,12 +734,13 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
             CMS.debug(method + eAudit2);
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY,
+                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_FAILURE,
                     auditSubjectID,
                     ILogger.FAILURE,
                     auditReqType,
                     auditCertSubject,
-                    auditSignerInfo);
+                    auditSignerInfo,
+                    eAudit2.toString());
 
             audit(auditMessage);
 
@@ -717,17 +750,70 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
             CMS.debug(method + eAudit3);
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
-                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY,
+                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_FAILURE,
                     auditSubjectID,
                     ILogger.FAILURE,
                     auditReqType,
                     auditCertSubject,
-                    auditSignerInfo);
+                    auditSignerInfo,
+                    eAudit3.toString());
 
             audit(auditMessage);
 
             // rethrow the specific exception to be handled later
             throw eAudit3;
+        } catch (Exception eAudit4) {
+            CMS.debug(method + eAudit4);
+            // store a message in the signed audit log file
+            auditMessage = CMS.getLogMessage(
+                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_FAILURE,
+                    auditSubjectID,
+                    ILogger.FAILURE,
+                    auditReqType,
+                    auditCertSubject,
+                    auditSignerInfo,
+                    eAudit4.toString());
+
+            audit(auditMessage);
+
+            // rethrow the specific exception to be handled later
+            throw eAudit4;
+        }
+    }
+
+    /*
+    * verifySelfSignedCMC() verifies the following
+    * a. the required (per RFC 5272) SKI extension in the request matches that in the
+    *    SignerIdentifier
+    * b. the signature in the request
+    */
+    protected void verifySelfSignedCMC(
+            org.mozilla.jss.pkix.cms.SignerInfo signerInfo,
+            OBJECT_IDENTIFIER id)
+            throws EBaseException {
+        String method = "CMCUserSignedAuth: verifySelfSignedCMC: ";
+        CMS.debug(method + "begins");
+        try {
+            SignerIdentifier sid = signerInfo.getSignerIdentifier();
+            OCTET_STRING subjKeyId = sid.getSubjectKeyIdentifier();
+            KeyIdentifier keyIdObj =
+                    (KeyIdentifier) selfsign_skiExtn.get(SubjectKeyIdentifierExtension.KEY_ID);
+            boolean match = CryptoUtil.compare(subjKeyId.toByteArray(), keyIdObj.getIdentifier());
+            if (match) {
+                CMS.debug(method +
+                        " SignerIdentifier SUBJECT_KEY_IDENTIFIER matches SKI of request");
+            } else {
+                CMS.debug(method +
+                        " SignerIdentifier SUBJECT_KEY_IDENTIFIER failed to match");
+                throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
+            }
+            // verify sig using public key in request
+            CMS.debug(method + "verifying request signature with public key");
+            signerInfo.verify(selfsign_digest, id, selfsign_pubK);
+            CMS.debug(method + " signature verified");
+        } catch (Exception e) {
+            CMS.debug(method + e.toString());
+            throw new EBaseException(method + e.toString());
         }
     }
 
@@ -825,10 +911,24 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                 level, "CMC User Signed Authentication: " + msg);
     }
 
-    protected IAuthToken verifySignerInfo(AuthToken authToken, SignedData cmcFullReq) throws EBaseException {
+    /**
+     * User-signed CMC requests can be signed in two ways:
+     * a. signed with previously issued user signing cert
+     * b. self-signed with the private key paired with the public key in
+     * the request
+     *
+     * In case "a", the resulting authToke would contain
+     * (IAuthManager.CRED_CMC_SIGNING_CERT, signing cert serial number)
+     * In case "b", the resulting authToke would not contain the attribute
+     * IAuthManager.CRED_CMC_SIGNING_CERT
+     */
+    protected IAuthToken verifySignerInfo(
+            SessionContext auditContext, // to capture info in case of failure
+            AuthToken authToken,
+            SignedData cmcFullReq)
+            throws EBaseException {
         String method = "CMCUserSignedAuth: verifySignerInfo: ";
         CMS.debug(method + "begins");
-
         EncapsulatedContentInfo ci = cmcFullReq.getContentInfo();
         OBJECT_IDENTIFIER id = ci.getContentType();
         OCTET_STRING content = ci.getContent();
@@ -849,13 +949,10 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
             //if request key is used for signing, there MUST be only one signerInfo
             //object in the signedData object.
             for (int i = 0; i < numDig; i++) {
-                AlgorithmIdentifier dai =
-                        (AlgorithmIdentifier) dais.elementAt(i);
-                String name =
-                        DigestAlgorithm.fromOID(dai.getOID()).toString();
+                AlgorithmIdentifier dai = (AlgorithmIdentifier) dais.elementAt(i);
+                String name = DigestAlgorithm.fromOID(dai.getOID()).toString();
 
-                MessageDigest md =
-                        MessageDigest.getInstance(name);
+                MessageDigest md = MessageDigest.getInstance(name);
 
                 byte[] digest = md.digest(content.toByteArray());
 
@@ -867,6 +964,7 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
 
             for (int i = 0; i < numSis; i++) {
                 org.mozilla.jss.pkix.cms.SignerInfo si = (org.mozilla.jss.pkix.cms.SignerInfo) sis.elementAt(i);
+                //selfsign_SignerInfo = (org.mozilla.jss.pkix.cms.SignerInfo) sis.elementAt(i);
 
                 String name = si.getDigestAlgorithm().toString();
                 byte[] digest = digs.get(name);
@@ -879,11 +977,14 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                     digest = md.digest(ostream.toByteArray());
 
                 }
+
                 // signed  by  previously certified signature key
                 SignerIdentifier sid = si.getSignerIdentifier();
-                // TODO: need to handle signing key being the matching key from
-                // the request
                 if (sid.getType().equals(SignerIdentifier.ISSUER_AND_SERIALNUMBER)) {
+                    CMS.debug(method + "SignerIdentifier type: ISSUER_AND_SERIALNUMBER");
+                    selfSigned = false;
+                    CMS.debug(method + "selfSigned is false");
+
                     IssuerAndSerialNumber issuerAndSerialNumber = sid.getIssuerAndSerialNumber();
                     // find from the certs in the signedData
                     java.security.cert.X509Certificate cert = null;
@@ -899,14 +1000,12 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                             Name issuer = certI.getIssuer();
 
                             byte[] issuerB = ASN1Util.encode(issuer);
-CMS.debug(method + "issuer = " + new String(issuerB));
                             INTEGER sn = certI.getSerialNumber();
                             // if this cert is the signer cert, not a cert in the chain
                             if (new String(issuerB).equals(new String(
                                     ASN1Util.encode(issuerAndSerialNumber.getIssuer())))
                                     && sn.toString().equals(issuerAndSerialNumber.getSerialNumber().toString())) {
-                                ByteArrayOutputStream os = new
-                                        ByteArrayOutputStream();
+                                ByteArrayOutputStream os = new ByteArrayOutputStream();
 
                                 certJss.encode(os);
                                 certByteArray = os.toByteArray();
@@ -919,13 +1018,23 @@ CMS.debug(method + "issuer = " + new String(issuerB));
 
                             }
                         }
+
                         CMS.debug(method + "start checking signature");
+                        String CN = null;
                         if (cert == null) {
                             // find from certDB
                             CMS.debug(method + "verifying signature");
                             si.verify(digest, id);
                         } else {
                             CMS.debug(method + "found signing cert... verifying");
+
+                            //capture auditSubjectID first in case of failure
+                            netscape.security.x509.X500Name tempPrincipal =
+                                    (X500Name) x509Certs[0].getSubjectDN();
+                            CN = tempPrincipal.getCommonName(); //tempToken.get("userid");
+                            CMS.debug(method + " Principal name = " + CN);
+                            auditContext.put(SessionContext.USER_ID, CN);
+
                             PublicKey signKey = cert.getPublicKey();
                             PrivateKey.Type keyType = null;
                             String alg = signKey.getAlgorithm();
@@ -942,21 +1051,24 @@ CMS.debug(method + "issuer = " + new String(issuerB));
                                 pubK = PK11ECPublicKey.fromSPKI(/*keyType,*/ publicKeyData);
                             } else {
                                 CMS.debug(method + "unsupported signature algorithm: " + alg);
-                                throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
+                                s.close();
+                                throw new EInvalidCredentials(
+                                        CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
                             }
 
-                            String tokenName =
-                                CMS.getConfigStore().getString("ca.requestVerify.token", CryptoUtil.INTERNAL_TOKEN_NAME);
+                            String tokenName = CMS.getConfigStore().getString("ca.requestVerify.token",
+                                    CryptoUtil.INTERNAL_TOKEN_NAME);
                             // by default JSS will use internal crypto token
                             if (!CryptoUtil.isInternalToken(tokenName)) {
                                 savedToken = cm.getThreadToken();
                                 signToken = CryptoUtil.getCryptoToken(tokenName);
-                                if(signToken != null) {
+                                if (signToken != null) {
                                     cm.setThreadToken(signToken);
                                     tokenSwitched = true;
-                                    CMS.debug(method + "verifySignerInfo token switched:"+ tokenName);
+                                    CMS.debug(method + "verifySignerInfo token switched:" + tokenName);
                                 } else {
-                                    CMS.debug(method + "verifySignerInfo token not found:"+ tokenName+ ", trying internal");
+                                    CMS.debug(method + "verifySignerInfo token not found:" + tokenName
+                                            + ", trying internal");
                                 }
                             }
 
@@ -967,6 +1079,7 @@ CMS.debug(method + "issuer = " + new String(issuerB));
                         // verify signer's certificate using the revocator
                         if (!cm.isCertValid(certByteArray, true, CryptoManager.CertUsage.SSLClient)) {
                             CMS.debug(method + "CMC signature failed to be verified");
+                            s.close();
                             throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
                         } else {
                             CMS.debug(method + "CMC signature verified; but signer not yet;");
@@ -974,23 +1087,38 @@ CMS.debug(method + "issuer = " + new String(issuerB));
                         // At this point, the signature has been verified;
 
                         IAuthToken tempToken = new AuthToken(null);
+/*
                         netscape.security.x509.X500Name tempPrincipal = (X500Name) x509Certs[0].getSubjectDN();
                         String CN = tempPrincipal.getCommonName(); //tempToken.get("userid");
                         CMS.debug(method + " Principal name = " + CN);
+*/
 
                         BigInteger certSerial = x509Certs[0].getSerialNumber();
                         CMS.debug(method + " verified cert serial=" + certSerial.toString());
                         authToken.set(IAuthManager.CRED_CMC_SIGNING_CERT, certSerial.toString());
                         tempToken.set("cn", CN);
 
+                        s.close();
                         return tempToken;
 
+                    } else {
+                        CMS.debug(method + "no certificate found in cmcFullReq");
                     }
-
+                } else if (sid.getType().equals(SignerIdentifier.SUBJECT_KEY_IDENTIFIER)) {
+                    CMS.debug(method + "SignerIdentifier type: SUBJECT_KEY_IDENTIFIER");
+                    CMS.debug(method + "selfSigned is true");
+                    selfSigned = true;
+                    selfsign_digest = digest;
+
+                    IAuthToken tempToken = new AuthToken(null);
+                    authToken.set(IAuthManager.CRED_CMC_SELF_SIGNED, "true");
+                    s.close();
+                    return tempToken;
                 } else {
                     CMS.debug(method + "unsupported SignerIdentifier type");
                 }
-            }
+            } //for
+
         } catch (InvalidBERException e) {
             CMS.debug(method + e.toString());
         } catch (IOException e) {
@@ -1001,7 +1129,7 @@ CMS.debug(method + "issuer = " + new String(issuerB));
             CMS.debug(method + e.toString());
             throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
         } finally {
-            if ((tokenSwitched == true) && (savedToken != null)){
+            if ((tokenSwitched == true) && (savedToken != null)) {
                 cm.setThreadToken(savedToken);
                 CMS.debug(method + "verifySignerInfo token restored");
             }
@@ -1123,8 +1251,7 @@ CMS.debug(method + "issuer = " + new String(issuerB));
         SessionContext auditContext = SessionContext.getExistingContext();
 
         if (auditContext != null) {
-            subjectID = (String)
-                    auditContext.get(SessionContext.USER_ID);
+            subjectID = (String) auditContext.get(SessionContext.USER_ID);
 
             if (subjectID != null) {
                 subjectID = subjectID.trim();
